function [res_classplsda] = classplsda(x,y,lv)


    // distributed under the CeCILL-C license
    // copyright INRA-IRSTEA 2013    

    
    // Initialisation:
    [n,q]=size(x);
    
   
    y=conj2dis(y);                 // modifié 24juin2014
    ngroups=size(,2);
    
    loadings=zeros(q,lv,ngroups);
    scores=zeros(n,lv,ngroups);

    //calcul de pinv(X'X):
    Xx = x'*x;
    tol = norm(size(Xx),'inf')*norm(Xx)*%eps;   //default tolerance value
    tol = tol*10;                               //customized tolerance value
    s = pinv(Xx,tol);
    s=(s+s')/2;                //so S is perfectly symmetrical! 

    // calcul des scores et loadings pour chaque groupe:
    for i=1:ngroups;
        res=ikpls(x,y(:,i),2,lv,0);
        scores(:,:,i)=res.scores.d;
        loadings(:,:,i)=res.loadings.d;
    end
    
    // Outputs:
    res_classplsda.scores=scores;
    res_classplsda.loadings=loadings;
    res_classplsda.m_metric=s;


    
endfunction
