function [model_pds]=pds_calc(xa,xb,k)
    
    // method: piecewise and direct standardization transform
    // k doit etre impair 
    // xa et xb: 2 matrices de spectres acquis sur les appareils A et B
    // on calcule la matrice qui permettra de transformer les spectres acquis sur B en spectres acquis sur A
    
    // xa^= xb * p
    
    
    xa0=div(xa);    
    xb0=div(xb); 
    [n,q]=size(xb0.d);
    
    [xa,xa_mean]=centering(xa);
    [xb,xb_mean]=centering(xb);
    
    
    p=zeros(q,q);
    r=(k-1)/2;
    
    // centre de la matrice p
    for i=r+1:q-r;  
        xa_im1=xa.d(:,i-1);
        xai=xa.d(:,i);
        xa_ip1=xa.d(:,i+1);
        xbi=xb.d(:,i-r:i+r);
        if i==r+1 | i==q-r then               // correction 22juin2016
            bi=pinv(xbi'*xbi)*xbi'*xai;  
            p(i-r:i+r,i)=p(i-r:i+r,i) + bi;
        elseif i==r+2 then 
            bi=   pinv(xbi'*xbi)*xbi'*xai;
            p(i-r:i+r,i)  =p(i-r:i+r,i)   + 0.75*bi;
            p(i-r:i+r,i+1)=p(i-r:i+r,i+1) + 0.25*bi;
        elseif i==q-r-1 then  
            bi=   pinv(xbi'*xbi)*xbi'*xai;
            p(i-r:i+r,i-1)=p(i-r:i+r,i-1) + 0.25*bi;
            p(i-r:i+r,i)  =p(i-r:i+r,i)   + 0.75*bi;
        else
            b_im1=pinv(xbi'*xbi)*xbi'*xa_im1; 
            bi=   pinv(xbi'*xbi)*xbi'*xai;
            b_ip1=pinv(xbi'*xbi)*xbi'*xa_ip1;
            p(i-r:i+r,i-1)=p(i-r:i+r,i-1) + 0.25*bi;
            p(i-r:i+r,i)  =p(i-r:i+r,i)   + 0.5*bi;
            p(i-r:i+r,i+1)=p(i-r:i+r,i+1) + 0.25*bi;
        end
    end
    
    // debut de la matrice p:
    for i=1:r;
        xai=xa.d(:,i);
        xbi=xb.d(:,1:r+i);   
        bi=pinv(xbi'*xbi)*xbi'*xai;   
        p(1:r+i,i)=bi;
    end
    
    // fin de la matrice p:
    for i=q-r+1:q;         
        xai=xa.d(:,i);
        xbi=xb.d(:,i-r:q);    
        bi=pinv(xbi'*xbi)*xbi'*xai;  
        p(i-r:q,i)=bi;
    end
    
    
    pout.d=p;
    pout.i=xb0.v;
    pout.v=xa0.v;
    pout=div(pout);
    
    
    model_pds.p=[];
    model_pds.p=pout;
    model_pds.xa_mean=[];
    model_pds.xa_mean=xa_mean;
    model_pds.xb_mean=[];
    model_pds.xb_mean=xb_mean;
    model_pds.window=k;
    
    
endfunction
